var ysgToolbar = {
	// Event listener to complete browser loading
	onLoad: function(e) {
		// Default setting
		ysgToolbar.setDefLItrURL();

		// Checking YSG link event listener
		document.getElementById("ysgtoolbar-mb").addEventListener("command", function(e) { ysgToolbar.onGoHome(e); }, false);
		document.getElementById("ysgtoolbar-mb-home").addEventListener("command", function(e) { ysgToolbar.onGoHome(e); }, false);
		document.getElementById("ysgtoolbar-mb-pref").addEventListener("command", function(e) { ysgToolbar.onOpenPref(e); }, false);

		gBrowser.addEventListener("load", function(e) { ysgToolbar.onPageLoad(e); }, false);
		gBrowser.tabContainer.addEventListener("TabSelect", function(e) { ysgToolbar.onPageLoad(e); }, false);
		document.getElementById("ysgtoolbar-blin").addEventListener("command", function(e) { ysgToolbar.onLogin(e); }, false);
	},


	// Event listener to go to YggDore homepage
	onGoHome: function(e) {
		var home = document.getElementById("ysgtoolbar-strings").getString("homeURL");
		if(!home){
			return;
		}

		gBrowser.loadURI(home);

		e.cancelBubble = true;
	},


	// Event listener to go to YggDore homepage
	onOpenPref: function(e) {
		window.openDialog(
			"chrome://ysgtoolbar/content/options.xul",
			"options",
			"chrome",
			"ysg-pref"
		);

		e.cancelBubble = true;
	},


	// Event listener to complete page loading
	onPageLoad: function(e) {
		ysgToolbar.enableLoginButton(ysgToolbar.getYSGURL());
	},


	// Login button event listener
	onLogin: function(e) {
		var ysgurl = ysgToolbar.getYSGURL();
		if(!ysgurl){
			return;
		}

		var litrurl = ysgToolbar.getLItrURL();
		if(!litrurl){
			return;
		}

		var req = new XMLHttpRequest();
		req.open("GET", litrurl, true);
		req.onload = function(e) {
			var litri = ysgToolbar.parseLItrXML(req.responseXML);
			if(!litri){
				return;
			}

			ysgToolbar.loadURIWithPOST(
				litri['Server'].value,
				ysgToolbar.createLoginQuery(litri, ysgurl)
			);
		};
		req.send(null);
	},


	// Set login button status
	enableLoginButton: function(ise) {
		document.getElementById("ysgtoolbar-blin").disabled = !ise;
	},


	// Get YggDore Sky Gate URL in meta tag
	getYSGURL: function() {
		var metas  = gBrowser.selectedBrowser.contentDocument.getElementsByTagName("meta");
		var ysgurl = null;
		var name	 = null;
		for(var i = 0; i < metas.length; i++){
			name = metas[i].getAttribute("name");
			if(!name){
				continue;
			}
			else if(name.toLowerCase() != "ysg"){
				continue;
			}

			ysgurl = metas[i].getAttribute("content");
			if(!ysgurl){
				continue;
			}

			break;
		}

		return ysgurl;
	},


	// Get URL to login interface
	getLItrURL: function() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
									.getService(Components.interfaces.nsIPrefService);

		try{
			prefs = prefs.getBranch("extensions.ysgtoolbar.");
			if(!prefs){
				return "";
			}

			var litr = prefs.getCharPref("yslitr");
			if(litr){
				return litr;
			}
		}
		catch( e ){
		}
		

		litr = document.getElementById("ysgtoolbar-strings").getString("prefDefYSLItr");
		if(!litr){
			return "";
		}

		return litr;
	},


	// Set default setting
	setDefLItrURL: function() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
									.getService(Components.interfaces.nsIPrefService);

		var litr = null;
		try{
			prefs = prefs.getBranch("extensions.ysgtoolbar.");
			if(!prefs){
				return;
			}

			litr = prefs.getCharPref("yslitr");
		}
		catch( e ){
		}
		
		if(litr){
			return;
		}

		litr = document.getElementById("ysgtoolbar-strings").getString("prefDefYSLItr");
		if(!litr){
			return;
		}

		prefs.setCharPref("yslitr", litr);
	},


	// Parse login interface XML
	parseLItrXML: function(xml) {
		if(!xml){
			return null;
		}

		var dom = xml.firstChild;
		if(!dom || dom.tagName != "Interface"){
			return null;
		}

		var gtbl = [
			[ "Server", [], true ],
			[ "Service", [ "key" ], false ],
			[ "IID", [ "key" ], true ],
			[ "ID", [ "key" ], false ],
			[ "Password", [ "key", "challenge" ], false ]
		]
		var litri = {};
		var tags;
		var i, j;
		for(i = 0; i < gtbl.length; i++){
			var tnm = gtbl[i][0];
			var atl = gtbl[i][1];
			var isv = gtbl[i][2];

			tags = dom.getElementsByTagName(tnm);
			if(!tags || tags.length <= 0){
				return null;
			}

			var at = {};
			for(j = 0; j < atl.length; j++){
				at[atl[j]] = tags[0].getAttribute(atl[j]);
				if(!at[atl[j]]){
					return null;
				}
			}

			var v = null;
			if(isv){
				if(!tags[0].firstChild){
					return null;
				}
				
				v = tags[0].firstChild.nodeValue;
				if(!v){
					return null;
				}
			}

			litri[tnm] = { attr: at, value: v };
		}

		tags = dom.getElementsByTagName("Query");
		if(!tags || tags.length <= 0){
			litri['Query'] = null;
			return litri;
		}

		tags = tags[0].getElementsByTagName("Record");
		if(!tags || tags.length <= 0){
			litri['Query'] = null;
			return litri;
		}

		var query = [];
		for(i = 0; i < tags.length; i++){
			var k = tags[i].getAttribute("key");
			if(!k){
				return null;
			}

			var v = "";
			if(tags[i].firstChild){
				v = tags[i].firstChild.nodeValue;
				if(!v){
					v = "";
				}
			}

			query[i] = { attr: { key: k }, value: v };
		}

		litri['Query'] = query;

		return litri;
	},


	// Create sha1
	createSHA1: function(str) {
		var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);

		converter.charset = "UTF-8";

		var result = {};
		var data   = converter.convertToByteArray(str, result);

		var ch = Components.classes["@mozilla.org/security/hash;1"]
                   .createInstance(Components.interfaces.nsICryptoHash);
		ch.init(ch.SHA1);
		ch.update(data, data.length);
		var hash = ch.finish(false);

		var rts = "";
		for(var i = 0; i < hash.length; i++){
			rts += ("0" + hash.charCodeAt(i).toString(16)).slice(-2);
		}

		return rts;
	},


	// Create password from challenge
	createPassword: function(ps, chal) {
		return ysgToolbar.createSHA1( ysgToolbar.createSHA1(ps) + chal );
	},


	// Create login query data
	createLoginQuery: function(litri, ysgurl) {
		var lid = document.getElementById("ysgtoolbar-lid").value;
		var lps = document.getElementById("ysgtoolbar-lps").value;

		lps = ysgToolbar.createPassword(lps, litri['Password'].attr.challenge);

		var rts =
			encodeURIComponent(litri['IID'].attr.key) + "=" +
			encodeURIComponent(litri['IID'].value) + "&" +
			encodeURIComponent(litri['ID'].attr.key) + "=" +
			encodeURIComponent(lid) + "&" +
			encodeURIComponent(litri['Password'].attr.key) + "=" +
			encodeURIComponent(lps) + "&" +
			encodeURIComponent(litri['Service'].attr.key) + "=" +
			encodeURIComponent(ysgurl);
		if(!litri['Query']){
			return rts;
		}

		for(var i = 0; i < litri['Query'].length; i++){
			var rec = litri['Query'][i];
			rts += "&" +
				encodeURIComponent(rec.attr.key) + "=" +
				encodeURIComponent(rec.value);
		}

		return rts;
	},


	// Create POST query data
	createPOSTQuery: function(query) {
		if(!query){
			return null;
		}

		var content =
			"Content-Type: application/x-www-form-urlencoded\n" +
			"Content-Length: " + query.length + "\n\n" +
			query;

		var post = Components
				.classes['@mozilla.org/io/string-input-stream;1']
				.createInstance(Components.interfaces.nsIStringInputStream);
		post.setData(content, content.length);

		return post;
	},


	// Jump to the site specified url with POST query data
	loadURIWithPOST: function(url, query) {
		gBrowser.loadURIWithFlags(
			url,
			Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
			null,
			null,
			ysgToolbar.createPOSTQuery(query)
		);
	},

};

window.addEventListener("load", function(e) { ysgToolbar.onLoad(e); }, false);
